src/apps/ecidadania/proposals/urls.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Proposal module URLs.
"""

from django.conf.urls import *

from apps.ecidadania.proposals.views.common import ViewProposal, \
    support_proposal
from apps.ecidadania.proposals.views.proposals import AddProposal, \
    EditProposal, DeleteProposal, ListProposals
from apps.ecidadania.proposals.views.proposalsets import AddProposalSet, \
    EditProposalSet, DeleteProposalSet, add_proposal_field, \
    delete_proposal_field, proposal_to_set, mergedproposal_to_set, \
    ListProposalSet, ViewProposalSet, AddProposalInSet
from apps.ecidadania.proposals.url_names import *


urlpatterns = patterns('apps.ecidadania.proposals.views',

    url(r'^set/$', ListProposalSet.as_view(), name=PROPOSALSET_LIST),

    url(r'^set/(?P<set_id>\w+)/$', ViewProposalSet.as_view(),
        name=PROPOSALSET_VIEW),

    url(r'^set/(?P<set_id>\w+)/add/$', AddProposalInSet.as_view(),
        name=PROPOSAL_ADD_INSET),

    url(r'^add/$', AddProposal.as_view(), name=PROPOSAL_ADD),

    url(r'^add/set/$', AddProposalSet.as_view(), name=PROPOSALSET_ADD),

    url(r'^add/field/', 'proposalsets.add_proposal_field',
        name=PROPOSALFIELD_ADD),

    url(r'^edit/(?P<prop_id>\w+)/', EditProposal.as_view(),
        name=PROPOSAL_EDIT),

    url(r'^edit/set/(?P<p_set>\w+)/', EditProposalSet.as_view(),
        name=PROPOSALSET_EDIT),

    url(r'^delete/field/$', 'proposalsets.delete_proposal_field',
        name=PROPOSALFIELD_DELETE),

    url(r'^delete/(?P<prop_id>\w+)/$', DeleteProposal.as_view(),
        name=PROPOSAL_DELETE),

    url(r'^delete/set/(?P<p_set>\w+)/$', DeleteProposalSet.as_view(),
        name=PROPOSALSET_DELETE),

    url(r'^support/', 'common.support_proposal', name=PROPOSAL_VOTE),

    url(r'^merge/(?P<set_id>\w+)/', 'proposals.merge_proposal',
        name=PROPOSAL_MERGED),

    url(r'^merge_proposals/', 'proposalsets.mergedproposal_to_set',
        name=PROPOSAL_MERGEDTOSET),

    url(r'^select_set/', 'proposalsets.proposal_to_set', name=SELECT_SET),

    url(r'^(?P<prop_id>\w+)/$', ViewProposal.as_view(), name=PROPOSAL_VIEW),

    url(r'^$', ListProposals.as_view(), name=PROPOSAL_LIST),

    # url(_(r'^(?P<space_url>\w+)/vote/approve/(?P<token>\w+)/$'),
    #    ValidateVote.as_view(), name=VALIDATE_VOTE),
)

src/core/prismriver/dashboard/urls.py
from django.conf.urls.defaults import *

urlpatterns = patterns('', url(r'^$', 'prismriver.dashboard.views.dashboard'))

src/e_cidadania/urls.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Main URLs for the e-cidadania platform.
"""

from django.conf.urls import *
from django.conf import settings
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

admin.autodiscover()

# We put here the dictionary with all the packages for translatin JavaScript code
# Please refer to https://docs.djangoproject.com/en/dev/topics/i18n/internationalization/#specifying-translation-strings-in-javascript-code
js_info_dict = {
    'packages': ('apps.ecidadania.debate',),
}

urlpatterns = patterns('',
    # i18n switcher
    (r'^i18n/', include('django.conf.urls.i18n')),
)

urlpatterns += patterns('',

    # Django administration
    (r'^admin/', include(admin.site.urls)),

    # Index
    url(r'^$', 'core.views.index.index_view', name='site-index'),

    # User accounts
    url(r'^accounts/', include('apps.thirdparty.userprofile.urls')),

    # REST API
    url(r'^api/', include('apps.ecidadania.api.urls')),

    # Spaces
    url(r'^spaces/', include('core.spaces.urls')),

    # Invitations
    url(r'^invite/', 'core.views.invite.invite', name='invite'),

    # Explore
    url(r'^explore/$', 'core.views.explore.explore', name='explore'),

    # This urls is for the django comments system
    url(r'^comments/', include('django.contrib.comments.urls')),

    (r'^jsi18n/$', 'django.views.i18n.javascript_catalog', js_info_dict),

    # For smart_selects app
    url(r'^chaining/', include('apps.thirdparty.smart_selects.urls')),

    # This url is for the access to static pages. I hope this doesn't collide
    # with the index view
    url(r'^(?P<slug>[\w\-]+)/', include('apps.ecidadania.staticpages.urls')),

)

if settings.DEBUG:
    # Serve static files
    urlpatterns += staticfiles_urlpatterns()
    # Serve uploaded files
    urlpatterns += patterns('',
        url(r'^uploads/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
    )

src/apps/ecidadania/proposals/models.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Proposal data models are the ones to store the data inside the DB.
"""

import datetime
from django.core import urlresolvers

from django import forms
from django.db import models
from django.contrib.auth.models import User
from django.contrib.contenttypes import generic
from django.contrib.contenttypes.models import ContentType
from django.contrib.sites.models import Site
from django.utils.translation import ugettext_lazy as _
from django.conf import settings

from apps.thirdparty.tagging.fields import TagField
from apps.thirdparty.tagging.models import Tag
from core.spaces.models import Space
from apps.ecidadania.debate.models import Debate

CLOSE_REASONS = (
    (1, _('Economically not viable')),
    (2, _('Legally not viable')),
    (3, _('Technically not viable')),
    (4, _('Offtopic'))
)

OPTIONAL_FIELDS = (
    ('tags', _('Tags')),
    ('latitude', _('Latitude')),
    ('longitude', _('Longitude'))
)


class BaseProposalAbstractModel(models.Model):

    """
    Integrated generic relation into the proposal module, which will allow
    the proposal module to be related to any other module in e-cidadania.

    .. versionadded:: 0.1.5b

    :automatically filled fields: contype_type, object_pk

    """

    content_type = models.ForeignKey(ContentType, null=True, blank=True)
    object_pk = models.TextField(_('object ID'), null=True)
    content_object = generic.GenericForeignKey(ct_field="content_type", fk_field="object_pk")

    class Meta:
        abstract = True


class Category(BaseProposalAbstractModel):

    """
    Dummy class for proposal categories. Inherits directly from
    :class:`BaseClass` without adding any fields.
    """
    pass


class ProposalSet(models.Model):

    """
    ProposalSet date model. This will contain a group of proposal
    which will be created after the debate using the debate note after it is
    finished.

    .. addedversion:: 0.1.5b

    :automatically filled fields: space, author, pub_date, debate
    :user filled fields: Name

    """

    name = models.CharField(_('Name'), max_length=200, unique=True,
                            help_text=_('Max: 200 characters'))
    # ptype = models.CharField(_('Ponderation'), choices=PONDERATIONS,
    #     max_length=20, help_text=_('Ponderation types:<br><strong>Users: \
    #     </strong>Users give support votes to the proposal, and that votes \
    #     are added to the final voting.<br><strong>Fixed:</strong>Fixed \
    #     ponderations are stablished by the process managers. It\'s a \
    #     porcentual puntuation. That means that percetange is calculated \
    #     after the voting and added to the final voting.<br><strong>None: \
    #     </strong> No ponderation is applied to the final voting.'))
    space = models.ForeignKey(Space, blank=True, null=True)
    pub_date = models.DateTimeField(auto_now_add=True)
    author = models.ForeignKey(User, blank=True, null=True)
    debate = models.ForeignKey(Debate, blank=True, null=True,
        help_text=_('Select the debate associated with this proposal set'))

    def __unicode__(self):
        return self.name

    class Meta:
        verbose_name = _('Proposal set')
        verbose_name_plural = _('Proposal sets')
        get_latest_by = 'pub_date'
        permissions = (
            ('view_proposalset', 'Can view the ProposalSet'),
            ('admin_proposalset', 'Can administrate the ProposalSet'),
            ('mod_proposalset', 'Can moderate the ProposalSet'),
        )

    @models.permalink
    def get_absolute_url(self):
        return ('view-proposalset', (), {
            'space_url': self.space.url,
            'set_id': self.id
        })


class Proposal(BaseProposalAbstractModel):

    """
    Proposal data model. This will store the user proposal in a similar
    way that Stackoverflow does. Take in mind that this data model is very
    exhaustive because it covers the administrator and the user.

    :automatically filled fields: Space, Author, Pub_date, mod_date.
    :user filled fields: Title, Description, Tags, Latitude, Longitude.
    :admin fields (manual): Code, Closed, Close_reason, Anon_allowed,
                            Refurbished, Budget.
    :admin fields (auto): Closed_by
    :extra permissions: proposal_view

    :const:`CLOSE_REASONS` for :class:Proposal data model is hardcoded with four values, which will fit most of the requirements.
    """
    code = models.CharField(_('Code'), max_length=50, blank=True,
        null=True)
    title = models.CharField(_('Title'), max_length=100, unique=True,
        help_text=_('Max: 200 characters'))
    proposalset = models.ForeignKey(ProposalSet, related_name='proposal_in',
        blank=True, null=True, help_text=_('Proposal set in which the \
        proposal resides'))
    description = models.TextField(_('Description'), max_length=300)
    space = models.ForeignKey(Space, blank=True, null=True)
    author = models.ForeignKey(User, related_name='proposal_authors',
        blank=True, null=True, help_text=_('Change the user that will \
        figure as the author'))
    tags = TagField(help_text=_('Insert here relevant words related with \
        the proposal'))
    latitude = models.DecimalField(_('Latitude'), blank=True, null=True,
        max_digits=17, decimal_places=15, help_text=_('Specify it in decimal'))
    longitude = models.DecimalField(_('Longitude'), blank=True, null=True,
        max_digits=17, decimal_places=15, help_text=_('Specify it in decimal'))
    closed = models.NullBooleanField(default=False, blank=True)
    closed_by = models.ForeignKey(User, blank=True, null=True,
        related_name='proposal_closed_by')
    close_reason = models.SmallIntegerField(choices=CLOSE_REASONS, null=True,
        blank=True)
    merged = models.NullBooleanField(default=False, blank=True, null=True)
    merged_proposals = models.ManyToManyField('self', blank=True, null=True,
        help_text=_("Select proposals from the list"))

    anon_allowed = models.NullBooleanField(default=False, blank=True)
    support_votes = models.ManyToManyField(User, null=True, blank=True,
        verbose_name=_('Support votes from'), related_name='support_votes')
    votes = models.ManyToManyField(User, verbose_name=_('Votes from'),
        null=True, blank=True, related_name='voting_votes')
    refurbished = models.NullBooleanField(default=False, blank=True)
    budget = models.IntegerField(blank=True, null=True)

    pub_date = models.DateTimeField(auto_now_add=True)
    mod_date = models.DateTimeField(auto_now_add=True)

    def __unicode__(self):
        return self.title

    def set_tags(self, tags):
        Tag.objects.update_tags(self, tags)

    def get_tags(self, tags):
        return Tag.objects.get_for_object(self)

    class Meta:
        verbose_name = _('Proposal')
        verbose_name_plural = _('Proposals')
        get_latest_by = 'pub_date'
        permissions = (
            ('view_proposal', 'Can view the Proposal'),
            ('admin_proposal', 'Can administrate the Proposal'),
            ('mod_proposal', 'Can moderate the Proposal'),
        )

    @models.permalink
    def get_absolute_url(self):
        return ('view-proposal', (), {
            'space_url': self.space.url,
            'prop_id': str(self.id)})


class ProposalField(models.Model):

    """
    Proposal Fields data model. This will store details of addition form
    fields which can be optionally added the proposal form which is residing
    in a particular proposal set.

    user filled fields: proposalset, field_name
    const:`OPTIONAL_FIELD` for class:ProposalField is hardcoded with three
    field values, more fields can be added as need.

    """

    proposalset = models.ForeignKey(ProposalSet, help_text=_('Customizing \
        proposal form for a proposal set'), unique=False)
    field_name = models.CharField(max_length=100, choices=OPTIONAL_FIELDS, help_text=_('Additional field that needed to added to the proposal \
        form'))

    def __unicode__(self):
        return self.field_name

    class Meta:
        verbose_name = _('ProposalField')
        verbose_name_plural = _('ProposalFields')

src/apps/ecidadania/proposals/templates/proposals/proposal_confirm_delete.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Delete proposal" %}{% endblock %}
{% block logo %}
    {% if get_place %}
        <a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>
    {% endif %}
{% endblock %}
  
{% block banner %}
    {% if get_place %}
        <img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />
    {% endif %}
{% endblock %}

{% block content %}

    <div class="row">
        <div class="span12">
            <h4>{% trans "Delete proposal" %}</h4>
            <form action="" method="post">{% csrf_token %}
                <p>{% trans "Are you sure you want to delete this proposal? This action cannot be undone." %}</p>

                <hr />
                <a href="{{ get_place.get_absolute_url }}" class="btn btn-small">&laquo; {% trans "Go back" %}</a>
                <input class="btn btn-small btn-danger" type="submit" value="{% trans 'Delete' %}" />
            </form>
        </div>
    </div>

{% endblock %}

src/apps/ecidadania/proposals/templates/proposals/proposal_list.html
{% extends "base.html" %}
{% load i18n %}
{% load static from staticfiles %}
{% load comments %}

{% block title %}{% trans "View proposals" %}{% endblock %}
{% block logo %}
    {% if get_place %}
        <a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>
    {% endif %}
{% endblock %}

{% block banner %}
    {% if get_place %}
        <img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />
    {% endif %}
{% endblock %}

{% block space %}
    <a class="brand" href="{{ get_place.get_absolute_url }}">{{ get_place.name }}</a>
{% endblock %}

{% block content %}

    <div class="row">
        <div class="span8">
            {% for p in object_list %}
                <div id="proposal-wrapper">
                    {% if perms.proposals.add_proposal %}
                        <div id="tools">
                            <a href="{% url 'select_set' get_place.url %}"><img src="{% static 'assets/icons/add16.png' %}" alt="{% trans 'Add proposal' %}" title="{% trans 'Add proposal' %}"/></a> 
                            {% if perms.proposals.change_proposal %}
                                <a href="{% url 'edit-proposal' get_place.url p.id %}"><img src="{% static 'assets/icons/edit16.png' %}" alt="{% trans 'Edit' %}" title="{% trans 'Edit' %}"/></a> 
                            {% endif %}
                            {% if perms.proposals.delete_proposal %}
                                <a href="{% url 'delete-proposal' get_place.url p.id %}"><img src="{% static 'assets/icons/delete16.png' %}" alt="{% trans 'Delete' %}" title="{% trans 'Delete' %}"/></a>
                            {% endif %}
                        </div>
                    {% endif %}

                    <div class="span1">
                        <p style="line-height:30px;font-size:30px;margin-left:5px;">{{ p.support_votes.count }}</p>
                        <button style="margin-left:-15px;" onclick="upvote({{ p.id }})" class="btn btn-small" {% if user in p.support_votes.all %}disabled="disabled"{% endif %}>{% trans "support" %}</button>
                    </div>

                    <!-- Here goes the voting button -->
                    <div id="proposal">
                        <div class="title"><a href="{{ p.get_absolute_url }}">{{ p.title }}</a></div>
                        <div class="message">{{ p.message|truncatewords:12 }}</div>
                        {% get_comment_count for p as comment_count %}
                        <div class="creator">{% trans "proposed by " %} <a href="{% url 'profile_public' p.author %}">{{ p.author }}</a> {% if p.proposalset %}{% trans " on " %} <a href="{{ p.proposalset.get_absolute_url }}">{{ p.proposalset }}</a> {% endif %}|{% trans " at " %} {{ p.pub_date|date:"j/m/Y G:i" }} <a href="{{ p.get_absolute_url }}">{{ comment_count }} {% trans "comments" %}</a></div>
                    </div>
                    {% comment %}
                        The following div is to make the wrapper to wrap everything.
                    {% endcomment %}
                    <div style="clear:left;"></div>
                </div>
            {% empty %}
                <p>{% trans "There are no proposals for this space" %}.</p>
            {% endfor %}
    
            <hr />
            <a href="{% url 'space-index' get_place.url %}" class="btn small">&laquo; {% trans "Go back" %}</a>
  
            {% if is_paginated %}
                <div class="pagination">
                    <span class="page-links">
                        {% if page_obj.has_previous %}
                            <a href="{% url 'list-proposals' get_place.url %}?page={{ page_obj.previous_page_number }}">&laquo; {% trans "previous" %} | </a>
                        {% endif %}
                        <span class="page-current">
                            {{ page_obj.number }} {% trans "of" %} {{ page_obj.paginator.num_pages }}
                        </span>
                        {% if page_obj.has_next %}
                            <a href="{% url 'list-proposals' get_place.url %}?page={{ page_obj.next_page_number }}">| {% trans "next" %} &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            {% endif %}
        </div>
        <div class="span4">
        </div>
    </div>

{% endblock %}

src/apps/ecidadania/proposals/templates/proposals/proposalset_detail.html
{% extends "base.html" %}
{% load i18n %}
{% load static from staticfiles %}
{% load comments %}

{% block title %}{% trans "View Proposal Set" %}{% endblock %}
{% block logo %}<a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>{% endblock %}
{% block banner %}<img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />{% endblock %}

{% block extrajs %}
    <script src="http://www.openlayers.org/api/OpenLayers.js"></script>
    <script type="text/javascript">
        function upvote(proposal) {
            var request = $.ajax({
                type: "POST",
                url: "../../support/",
                data: { propid: proposal },
               success: function(data)
               {
               $("div.span1 button").attr('disabled', 'disabled');
               }

            });

            request.fail(function(jqXHR, textStatus) {
                $("#jsnotify").notify("create", {
                    title:"Couldn't vote the proposal",
                    text:"There has been an error." + textStatus,
                    icon:"alert.png"
                });
            })
        }
    </script>
{% endblock %}



{% block content %}

    <div class="row">
        <div class="span8">
            {% for p in proposalset %}
                <div id="proposal-wrapper">
                    {% if perms.proposals.add_proposal %}
                        <div id="tools">
                            <a href="{% url 'select_set' get_place.url %}"><img src="{% static 'assets/icons/add16.png' %}" alt="{% trans 'Add proposal' %}" title="{% trans 'Add proposal' %}"/></a> 
                            {% if perms.proposals.change_proposal %}
                                <a href="{% url 'edit-proposal' get_place.url p.id %}"><img src="{% static 'assets/icons/edit16.png' %}" alt="{% trans 'Edit' %}" title="{% trans 'Edit' %}"/></a> 
                            {% endif %}
                            {% if perms.proposals.delete_proposal %}
                                <a href="{% url 'delete-proposal' get_place.url p.id %}"><img src="{% static 'assets/icons/delete16.png' %}" alt="{% trans 'Delete' %}" title="{% trans 'Delete' %}"/></a>
                            {% endif %}
                        </div>
                    {% endif %}

                    <div class="span1">
                        <p style="line-height:30px;font-size:30px;margin-left:5px;">{{ p.support_votes.count }}</p>
                        <button style="margin-left:-15px;" onclick="upvote({{ p.id }})" class="btn btn-small" {% if user in p.support_votes.all %}disabled="disabled"{% endif %}>{% trans "support" %}</button>
                    </div>

                    <!-- Here goes the voting button -->
                    <div id="proposal">
                        <div class="title"><a href="{{ p.get_absolute_url }}">{{ p.title }}</a></div>
                        <div class="message">{{ p.message|truncatewords:12 }}</div>
                        {% get_comment_count for p as comment_count %}
                        <div class="creator">{% trans "proposed by " %} <a href="{% url 'profile_public' p.author %}">{{ p.author }}</a> {% trans " at " %} {{ p.pub_date|date:"j/m/Y G:i" }} | <a href="{{ p.get_absolute_url }}">{{ comment_count }} {% trans "comments" %}</a></div>
                    </div>
                    {% comment %}
                        The following div is to make the wrapper to wrap everything.
                    {% endcomment %}
                    <div style="clear:left;"></div>
                </div>
            {% empty %}
                <p>{% trans "There is no proposals in this set" %}.</p>
            {% endfor %}
    
            <hr />
            <a href="{% url 'space-index' get_place.url %}" class="btn small">&laquo; {% trans "Go back" %}</a>
  
            {% if is_paginated %}
                <div class="pagination">
                    <span class="page-links">
                        {% if page_obj.has_previous %}
                            <a href="{% url 'list-proposals' get_place.url %}?page={{ page_obj.previous_page_number }}">&laquo; {% trans "previous" %} | </a>
                        {% endif %}
                        <span class="page-current">
                            {{ page_obj.number }} {% trans "of" %} {{ page_obj.paginator.num_pages }}
                        </span>
                        {% if page_obj.has_next %}
                            <a href="{% url 'list-proposals' get_place.url %}?page={{ page_obj.next_page_number }}">| {% trans "next" %} &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            {% endif %}
        </div>
        <div class="span4">
        </div>
    </div>

{% endblock %}

src/apps/ecidadania/proposals/templates/proposals/proposalset_list.html
{% extends "base.html" %}
{% load i18n %}
{% load comments %}

{% block title %}{% trans "List all the proposal set" %}{% endblock %}
{% block logo %}
    {% if get_place %}
        <a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>
    {% endif %}
{% endblock %}

{% block banner %}
    {% if get_place %}
        <img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />
    {% endif %}
{% endblock %}

{% block space %}
    <a class="brand" href="{{ get_place.get_absolute_url }}">{{ get_place.name }}</a>
{% endblock %}

{% block content %}

    <div class="row">
        <div class="span8">
            {% for pset in object_list %}
                <div id="proposal-wrapper">
                    <div id="proposal">
                        <div class="title"><a href="{{ pset.get_absolute_url }}">{{ pset.name }}</a>
                            {% if perms.proposals.add_proposalset %}
                                <a class="nounderline" href="{% url 'add-proposalset' get_place.url %}" title="{% trans 'Add proposal set' %}">
                                    <i class="icon-plus" style="font-size:16px;"></i></a>
                                {% if perms.proposals.change_proposalset %}
                                    <a class="nounderline" href="{% url 'edit-proposalset' get_place.url pset.id %}" title="{% trans 'Edit proposal set' %}">
                                        <i class="icon-edit" style="font-size:16px;"></i></a>
                                {% endif %} 
                                {% if perms.proposals.delete_proposalset %}
                                    <a class="nounderline" href="{% url 'delete-proposalset' get_place.url pset.id %}" title="{% trans 'Delete proposal set' %}">
                                        <i class="icon-trash" style="font-size:16px;"></i></a>
                                {% endif %}
                            {% endif %}
                        </div>
                        <div class="creator">{% trans "Created by" %} <a href="">{{ pset.author }}</a> {% trans "at" %} {{ pset.pub_date|date:"j/m/Y G:i" }} </div>
                    </div>
                    <div style="clear:left;"></div>
                </div>
            {% empty %}
                <p>{% trans "There is no proposal set created" %}.</p>
            {% endfor %}
    
            <hr />
            <a href="{% url 'space-index' get_place.url %}" class="btn small">&laquo; {% trans "Go back" %}</a>
  
            {% if is_paginated %}
                <div class="pagination">
                    <span class="page-links">
                        {% if page_obj.has_previous %}
                            <a href="{% url 'list-proposalsets' get_place.url %}?page={{ page_obj.previous_page_number }}">&laquo; {% trans "previous" %} | </a>
                        {% endif %}
                        <span class="page-current">
                            {{ page_obj.number }} {% trans "of" %} {{ page_obj.paginator.num_pages }}
                        </span>
                        {% if page_obj.has_next %}
                            <a href="{% url 'list-proposalsets' get_place.url %}?page={{ page_obj.next_page_number }}">| {% trans "next" %} &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            {% endif %}
        </div>
        <div class="span4">
        </div>
    </div>

{% endblock %}